<?
/**
 * Action_Samurai_Spec
 * 
 * BDD(Behavior Driven Development)開発のためのツール
 * generatorアプリの下に置きたいが、WEB上からのテスト実行もあり得るのでこちらに配置。
 * 
 * @package    Samurai
 * @subpackage Action.Samurai
 * @copyright  Befool,Inc.
 * @author     Satoshi Kiuchi <satoshi.kiuchi@befool.co.jp>
 * @license    http://opensource.org/licenses/bsd-license.php  The modified BSD License
 */
class Action_Samurai_Spec extends Samurai_Action
{
    /**
     * 実行トリガー。
     * @access     public
     */
    public function execute()
    {
        parent::execute();
        //初期化
        $this->_init();
    }
    
    
    /**
     * 初期化。
     * @access     private
     */
    private function _init()
    {
        include_once('PHPSpec.php');
        $options = new stdClass;
        $options->recursive = true;
        $options->specdocs = true;
        $options->reporter = $this->Device->isCli() ? 'console' : 'html' ;
        if(Samurai_Config::get('generator.directory.samurai')){
            chdir(Samurai_Config::get('generator.directory.samurai') . DS . Samurai_Config::get('directory.spec'));
        } else {
            chdir(Samurai_Loader::getPath(Samurai_Config::get('directory.spec')));
        }
        PHPSpec_Runner::run($options);
        if($this->Device->isCli()) echo "\n";
    }
}
