<?
/**
 * Etc_File_Scanner
 * 
 * ファイルの走査をするクラス。
 * 
 * @package    Samurai
 * @subpackage Etc.File.Scanner
 * @copyright  Befool,Inc.
 * @author     Satoshi Kiuchi <satoshi.kiuchi@befool.co.jp>
 * @license    http://opensource.org/licenses/bsd-license.php  The modified BSD License
 */
Samurai_Loader::loadByClass('Samurai_Iterator');
Samurai_Loader::loadByClass('Etc_File_Scanner_Entity');
class Etc_File_Scanner
{
    /**
     * コンストラクタ。
     * @access     public
     */
    public function __construct()
    {
        
    }
    
    
    /**
     * 走査トリガー。
     * @access     public
     * @param      string  $directory   ディレクトリパス
     * @param      boolean $reflexive   再帰的に走査するかどうか
     * @return     object  Etc_File_Scanner_Entity
     */
    public function scan($directory, $reflexive=true)
    {
        $Iterator = new Samurai_Iterator();
        $Entity = new Etc_File_Scanner_Entity($directory);
        if($Entity->isDirectory()){
            $this->_scan($Iterator, $Entity, $reflexive);
        } else {
            throw new Samurai_Exception('No directory. -> {$directory}');
        }
        return $Iterator;
    }
    
    
    /**
     * 最もスタンダードな走査。
     * @access     private
     * @param      object  $Entity      Etc_File_Scanner_Entity
     * @param      boolean $reflexive   再帰的に走査するかどうか
     */
    private function _scan($Iterator, $DirEntity, $reflexive=true)
    {
        $files = scandir($DirEntity->path);
        foreach($files as $file){
            if($file != '.' && $file != '..'){
                $File = new Etc_File_Scanner_Entity($DirEntity->path . DS . $file);
                if($this->_match($File->path)){
                    $Iterator->addElement($File);
                }
                if($reflexive && $File->isDirectory()){
                    $this->_scan($Iterator, $File, $reflexive);
                }
            }
        }
    }
    
    
    /**
     * 条件との比較。
     * @access     private
     * @return     boolean 条件と一致するかどうか
     */
    private function _match()
    {
        return true;
    }
}
