<?
/**
 * Etc_File_Image_Converter_Worker_Gd
 * 
 * 画像のコンバートをサポートするコンポーネント
 * そのGDを使用して処理するWorker
 * 
 * @package    Samurai
 * @subpackage Etc.File.Image.Converter
 * @copyright  BEFOOL,Inc.
 * @author     Satoshi Kiuchi <satoshi.kiuchi@befool.co.jp>
 * @license    http://opensource.org/licenses/bsd-license.php  The modified BSD License
 */
class Etc_File_Image_Converter_Worker_Gd extends Etc_File_Image_Converter_Worker
{
    /**
     * コンバート実処理
     * @implements
     */
    protected function _convert()
    {
        $new_path = $this->Converter->dirname.'/'.$this->Converter->basename;
        $old_path = $this->Converter->original('dirname').'/'.$this->Converter->original('basename');
        
        //変換
        $image = imagecreatefromstring(file_get_contents($old_path));
        if($this->Converter->diff('width') || $this->Converter->diff('height')){
            $_image = imagecreatetruecolor($this->Converter->width, $this->Converter->height);
            imagecopyresampled($_image, $image, 0, 0, 0, 0,
                                $this->Converter->width, $this->Converter->height,
                                $this->Converter->original('width'), $this->Converter->original('height'));
            $image = $_image;
        }
        
        //保存
        switch($this->Converter->type){
            case IMAGETYPE_GIF:
                imagegif($image, $new_path);
                break;
            case IMAGETYPE_JPEG:
                imagejpeg($image, $new_path);
                break;
            case IMAGETYPE_PNG:
                imagepng($image, $new_path);
                break;
            case IMAGETYPE_WBMP:
                imagewbmp($image, $new_path);
                break;
            default:
                throw new Samurai_Exception('unsuported convert format. -> '.$this->Converter->type);
                break;
        }
        return $new_path;
    }
}
